package mschmidt.komo.preferences;
/*
 * Used to set General Preferences for the application.
 *
 */

import mschmidt.komo.ApplicationImages;
import mschmidt.komo.KomoPlugin;

import org.eclipse.jface.preference.BooleanFieldEditor;
import org.eclipse.jface.preference.FieldEditorPreferencePage;
import org.eclipse.swt.widgets.Label;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPreferencePage;

import mschmidt.komo.preferences.PreferenceConstants;

public class GeneralPreferences extends FieldEditorPreferencePage implements
		IWorkbenchPreferencePage {

	/**
	 * Create the preference page.
	 */
	public GeneralPreferences() {
		super(GRID);
		setPreferenceStore(KomoPlugin.getDefault().getPreferenceStore());
		setDescription("General Preferences");
		setTitle("General Preferences");
		setImageDescriptor(KomoPlugin
				.getImageDescriptor(ApplicationImages.CONFIGURE_ICON));

	}

	/**
	 * Create contents of the preference page.
	 */
	protected final void createFieldEditors() {

		// Create the field editors
		final BooleanFieldEditor toTrayEditor = new BooleanFieldEditor(
				PreferenceConstants.TO_TRAY, "Minimize to system tray",
				BooleanFieldEditor.SEPARATE_LABEL, getFieldEditorParent());
		final Label toTrayLabel = toTrayEditor.getLabelControl(getFieldEditorParent());
		toTrayLabel.setToolTipText("Check to show application icon in system tray");
		toTrayLabel.setText("&Minimize to system tray");
		addField(toTrayEditor);
		

		final BooleanFieldEditor confirmExitEditor = new BooleanFieldEditor(
				PreferenceConstants.CONFIRM_EXIT, "Confirm on exit",
				BooleanFieldEditor.SEPARATE_LABEL, getFieldEditorParent());
		final Label confirmExitLabel = confirmExitEditor
				.getLabelControl(getFieldEditorParent());
		confirmExitLabel
				.setToolTipText("Check to ask for confirmation to exit program");
		confirmExitLabel.setText("&Confirm on exit");
		addField(confirmExitEditor);

	}

	/* (non-Javadoc)
	 * @see org.eclipse.ui.
	 * IWorkbenchPreferencePage#init(org.eclipse.ui.IWorkbench).
	 */
	public void init(final IWorkbench workbench) {
		/*
		 * This line of code is needed for preferences to work properly in the
		 * RCP standalone application.
		 */		
		setPreferenceStore(KomoPlugin.getDefault().getPreferenceStore());
	}
}
